import processing.opengl.*;

/**********************************************************
*  Translation and Rotation Practice by Jim Roberts 3/6/8
***************************************************************/
final int NUMBER_OF_PANELS = 12;
final int MULTIPLIER = 50;

int rotY = 0;
int rotZ = 0;
int rotX = 0;

int transX, transY, transZ;

int centerX, centerY;
int x, y;


PImage image1;

float[ ] xPos = new float[NUMBER_OF_PANELS];
float[ ] zPos = new float[NUMBER_OF_PANELS];

void setup( )
{
  size(600, 600, OPENGL);
  x = width/2;
  y = height/2;
  noStroke();

  transX = width/2;
  transY = height/2;
  transZ = 0;
  
  image1 = loadImage("moose.jpg");
  
  initializeArrays( );
}

void  initializeArrays( )
{
    float angle = 360.0/NUMBER_OF_PANELS;
    for(int i = 0; i < NUMBER_OF_PANELS; i++)
    {
        xPos[i] = cos(radians(i * angle)) * MULTIPLIER;
        zPos[i] = sin(radians(i * angle)) * MULTIPLIER; 
    }
}

void draw()
{
    background( 0 );

    translate( transX, transY, transZ);
    rotateY(radians(rotY) );
    rotateX(radians(rotX) );
    rotateZ(radians(rotZ) );

    drawTube( );
}
void drawTube( )
{
  beginShape( QUAD_STRIP); 
    texture(image1);
    float imageY = image1.height;
    for(int i = 0; i < NUMBER_OF_PANELS; i++)
    {     
      float imageX = image1.width / NUMBER_OF_PANELS * i;
     
      // map image
      vertex(xPos[i], -100, zPos[i], imageX, 0);
      vertex(xPos[i],  100, zPos[i], imageX, imageY);
      
      // no image map
      //stroke( 0 );
      //vertex(xPos[i], -100, zPos[i]);
      //vertex(xPos[i],  100, zPos[i]);
    }   
  endShape(  ); 
}


//void checkKeys()

void keyPressed( )
{
   // the switch( 0 is a different form of the if/else
     switch(keyCode)
     {
       case LEFT    :  transX-=5; break; 
       case RIGHT   :  transX+=5; break;
       case UP      :  transY-=5; break; 
       case DOWN    :  transY+=5; break; 
       default: switch(key)
       {
         case 'x': rotX-=5;break; 
         case 'X': rotX+=5; break; 
         case 'y': rotY-=5; break; 
         case 'Y': rotY+=5; break; 
         case 'z': rotZ-=5; break; 
         case 'Z': rotZ+=5; break; 
         case 'c': 
         case 'C': transZ +=5; break; 
         case 'a': 
         case 'A': transZ-=5; break; 
         case ' ': transX = width/2;
                   transY = height/2;
                   transZ = 0;
                   rotX = 0;
                   rotY = 0;
                   rotZ = 0;
                   break;
        
       }
     }
  

}

