/*   95% of this code was written and posted  by yellowcap on May 26, 2010 on the Processing Forum
      from the Processing Forum page:
       http://processing.org/discourse/yabb2/YaBB.pl?num=1274893475
   
*/


import processing.opengl.*;

// Sphere Variables
float R = 250;
int xDetail = 40;
int yDetail = 30;
float[] xGrid = new float[xDetail+1];
float[] yGrid = new float[yDetail+1];
float[][][] allPoints = new float[xDetail+1][yDetail+1][3];

// Rotation Variables
float camDistance = -50;
float rotationX = 100;
float rotationY = 170;
float velocityX = 0;
float velocityY = 0;

// Texture
PImage texmap;

////////////////////////////////////////////////////////////////////////
void setup()
{
  size(700, 700, OPENGL);

  noStroke( );
  
  texmap = loadImage("p1.jpg");
  
  setupSphere(R, xDetail, yDetail);
}

void draw()
{  
  background(0);
  translate(width/2.0, height/2.0, camDistance);
  rotateX( radians(-rotationX) );  
  rotateZ( radians(270 - rotationY) );

  drawSphere(texmap);

  // Implements mouse control (interaction will be inverse when sphere is  upside down)
  rotationX += velocityX;
  rotationY += velocityY;
  // easing applied to motion
  velocityX *= 0.95;
  velocityY *= 0.95;
  if(mousePressed)
  {
    velocityX += (mouseY-pmouseY) * 0.01;
    velocityY -= (mouseX-pmouseX) * 0.01;
  }
}

// iniitalize arrays - called from setup -- saves some time
void setupSphere(float R, int xDetail, int yDetail)
{
  // Create a 2D grid of standardized mercator coordinates
  for(int i = 0; i <= xDetail; i++)
  {
    xGrid[i]= i / (float) xDetail;
  } 
  for(int i = 0; i <= yDetail; i++)
  {
    yGrid[i]= i / (float) yDetail;
  }

  textureMode(NORMAL);

  // Transform the 2D grid into a grid of points on the sphere, using the inverse mercator projection
  for(int i = 0; i <= xDetail; i++)
  {
    for(int j = 0; j <= yDetail; j++)
    {
      allPoints[i][j] = mercatorPoint(R, xGrid[i], yGrid[j]);
    }
  }
}

float[] mercatorPoint(float R, float x, float y)
{
  float[] thisPoint = new float[3];
  float phi = x*2*PI;
  float theta = PI - y*PI;

  thisPoint[0] = R*sin(theta)*cos(phi);
  thisPoint[1] = R*sin(theta)*sin(phi);
  thisPoint[2] = R*cos(theta);

  return thisPoint;
}

void drawSphere(PImage Map)
{
  for(int j = 0; j < yDetail; j++
  ){
    beginShape(TRIANGLE_STRIP);
    for(int i = 0; i <= xDetail; i++)
    {
      strokeWeight( 3 );
      stroke( 255,0,0 );

      point( allPoints[i][j+1][0],   allPoints[i][j+1][1],   allPoints[i][j+1][2] );

     //vertex(allPoints[i][j+1][0],   allPoints[i][j+1][1],   allPoints[i][j+1][2]);
     //vertex(allPoints[i][j][0],     allPoints[i][j][1],     allPoints[i][j][2]);
    }
    endShape(CLOSE);
    fill( 0, 0, 255 );
    strokeWeight( 1 );
    stroke(255 );
    sphere( 200 );
  }
}
 
